Class StaticRequestFilter

  • All Implemented Interfaces:
    org.forgerock.http.Filter

    public class StaticRequestFilter
    extends Object
    implements org.forgerock.http.Filter
    Creates a new request and send it down the next handler (effectively replacing the previous request). The request can include a form, specified in the form field, which is included in an entity encoded in application/x-www-form-urlencoded format if request method is POST, or otherwise as (additional) query parameters in the URI.
     
     {
          "method"                     : string            [REQUIRED]
          "uri"                        : expression        [REQUIRED]
          "entity"                     : expression        [OPTIONAL - cannot be used simultaneously
                                                                       with a form in POST mode* ]
          "form"                       : object            [OPTIONAL]
          "headers"                    : object            [OPTIONAL]
          "version"                    : string            [OPTIONAL]
     }
     
     

    *Nota: When method is set to POST, the entity and the form CANNOT be used together in the heaplet because they both determine the request entity. They still can used programmatically together but the form will override any entity content.

    Example of use:

     
     {
          "name": "customRequestFilter",
          "type": "StaticRequestFilter",
          "config": {
              "method": "POST",
              "uri": "http://10.10.0.2:8080/wp-login.php",
              "entity": "{\"auth\":{\"passwordCredentials\":
                         {\"username\":\"${attributes.username}\",
                          \"password\":\"${attributes.password}\"}}}"
              "headers": {
                  "Warning": [ "199 Miscellaneous warning" ]
              }
          }
     }
     
     
    • Constructor Detail

      • StaticRequestFilter

        public StaticRequestFilter​(String method)
        Builds a new StaticRequestFilter that will uses the given HTTP method on the resource.
        Parameters:
        method - The HTTP method to be performed on the resource
    • Method Detail

      • setEntity

        public void setEntity​(Expression<String> entity)
        Sets the message entity expression.
        Parameters:
        entity - The message entity expression.
      • setUri

        public void setUri​(Expression<String> uri)
        Sets the target URI as an expression to allow dynamic URI construction.
        Parameters:
        uri - target URI expression
      • setVersion

        public void setVersion​(String version)
        Sets the new request message's version.
        Parameters:
        version - Protocol version (e.g. "HTTP/1.1").
      • addHeaderValue

        public StaticRequestFilter addHeaderValue​(String key,
                                                  Expression<String> value)
        Adds a new header value using the given key with the given Expression. As headers are multi-valued objects, it's perfectly legal to call this method multiple times with the same key.
        Parameters:
        key - Header name
        value - Expression that represents the value of the new header
        Returns:
        this object for fluent usage
      • addFormParameter

        public StaticRequestFilter addFormParameter​(String name,
                                                    Expression<String> value)
        Adds a new form parameter using the given key with the given Expression. As form parameters are multi-valued objects, it's perfectly legal to call this method multiple times with the same key.
        Parameters:
        name - Form parameter name
        value - Expression that represents the value of the parameter
        Returns:
        this object for fluent usage
      • filter

        public org.forgerock.util.promise.Promise<org.forgerock.http.protocol.Response,​org.forgerock.util.promise.NeverThrowsException> filter​(org.forgerock.services.context.Context context,
                                                                                                                                                     org.forgerock.http.protocol.Request request,
                                                                                                                                                     org.forgerock.http.Handler next)
        Specified by:
        filter in interface org.forgerock.http.Filter